//Stringmanip.cpp

#include "Stringmanip.h"

///
/// checks that the string passed in is a number
/// @param str string to check
/// @return bool true for number
///
bool Stringmanip::isnumber(string str){
  for(unsigned int i=0; i<str.length(); i++){
    if((str[i]<'0'||str[i]>'9') && (str[i] != '.') && (str[i] != '-') && (str[i] != 'e')) {
      return false;
		}
		//if ( (str[i] == '-') && (i != 0)) {
		//	return false;
		//}
  }
  return true;
}

///
/// split string into tokens as defined by the delimiter
/// @param delim1 first string delimiter
/// @param delim2 second string delimiter
/// @param results vector of strings containing tokens
/// from the split string
/// @return number of results as int
///
int Stringmanip::split_string(const string& input, 
  string delim1, string delim2, vector<string>& results){
  int iPos = 0;
  int newPos = -1;
  string delimiter = delim1 + delim2;;

  int sizeS2 = 1;
  int isize = input.size();

  vector<unsigned int> positions;
  newPos = input.find_first_of (delimiter, 0);
  if( newPos < 0 ) { return 0; }

  int numFound = 0;

  while( newPos >= iPos ){
    numFound++;
    positions.push_back(newPos);
    iPos = newPos;
    newPos = input.find_first_of (delimiter, iPos+sizeS2);
  }

  for(unsigned int i=0; i <= positions.size(); i++ ){
    string s;
    if( i == 0 ) { 
      s = input.substr( i, positions[i] ); 
    }
    else {
   
      int offset = positions[i-1] + sizeS2;
      if( offset < isize )
	{
	  if( i == positions.size() )
	    {
	      s = input.substr(offset);
	    }
	  else if( i > 0 )
	    {
	      s = input.substr( positions[i-1] + sizeS2, 
				positions[i] - positions[i-1] - sizeS2 );
	    }
	}
    }

    if( s.size() > 0 )
    {
      results.push_back(s);
    }
  }
  return results.size();
}


///
/// converts string to integer
/// @param number string to convert
/// @return number as integer
///
int Stringmanip::stoi(string number){
    int value;
    stringstream ss(number);
    ss >> value;
    return value;
}

///
/// converts string to unsigned integer
/// @param number string to convert
/// @return number as unsigned integer
///
unsigned Stringmanip::stouint(string number){
  unsigned int value;
  stringstream ss(number);
  ss >> value;
  return value;
}

///
/// converts string to DATATYPE
/// @param number string to convert
/// @return number as DATATYPE
///
DATATYPE Stringmanip::stodata(string number){
  DATATYPE value;
  stringstream ss(number);
  ss >> value;
  return value;
}

INPUT_TYPE Stringmanip::stoinput(string number) {
	INPUT_TYPE_CAST value;

	//TODO:  Check and make sure this is within bounds.
	stringstream ss(number);
	ss >> value;
	return static_cast<INPUT_TYPE>(value);
}


///
/// Converts an unsigned int into the string representation
/// @param number to convert
/// @return number as a string
///
string Stringmanip::itos(unsigned int number){
  stringstream oss;
  oss << number;
  return oss.str();
}

///
/// Convert a double into the string representation
/// @param number to convert
/// @return number as a string
///
string Stringmanip::itos(double number){       
  stringstream oss;
  oss << number;
  return oss.str();
}

///
/// Converts an int into the string representation
/// @param number to convert
/// @return number as a string
///
string Stringmanip::itos(int number){       
  stringstream oss;
  oss << number;
  return oss.str();
}

