//Tester.cpp

#include "Tester.h"

///
/// In the beginning, there were none
///
int Tester::missing_count = 0;

///
/// Add an individual status value 
///
void Tester::add_status(int stat){
  ind_status.push_back(stat);
}

///
/// Add an individual trait value
///
void Tester::add_status_quan(DATATYPE trait) {
	ind_status_quan.push_back(trait);
}

///
/// Clear all the individuals' statuses in the Tester
///
void Tester::clear_status(){
  ind_status.clear();
	ind_status_quan.clear();
}


///
///  Returns the error rate of a particular network that
///  is represented as a set of operators in postfix notation762
///  @param postfix vector of operators
///  @return error rate
///

// S: Algo:
// Get the variable index from the tree_string
// For that variable index, check the SNP value from input
// Jump to that SNP value in tree_string for that variable
// check if the next element is a class or a variable
// if variable, repeat
// if class, act accordingly

// Here, input data is 2-d matrix, rows accesed by 'i' and cols accessed by 'j'
	
	
double Tester::determine_error_rate(vector<Element *> & tree){

  int vector_size = ind_status.size();
  int tree_size = tree.size();
  
/*
  vector<DATATYPE> stack;
  deque<DATATYPE> args;
  int num_args=0; //, total_wrong=0;
  vector <DATATYPE> results_quan;
*/
  unsigned int caseright=0, controlright=0;
   
  int total_right = 0;
  bool oneFound = false, twoFound = false;
  int temp, varFound = 0;
  
  DATATYPE SNPValue;
  int j,jump=0;
  int result;
  
  //checking tree_string
//  cout << endl << "Tree string is:\n";
//  for(int k=0;k<tree_size;k++)
//	  cout << tree[k]->get_name() << " ";
//  cout << endl;
  
  // for each individual evaluate the model
  // based on the tree_string
  for(int i=0; i<vector_size; i++) {
	//cout << "For individual " << i << endl;
    Variable::set_ind_index(i);
    j=0;
    try{
		while(tree[j]->get_isVariable()){
			//cout<< "Index " << j << " in the tree_string is a variable" << endl;
			SNPValue = tree[j]->evaluate();		//comes from the input
			//cout<< "Its SNP Value is " << SNPValue << endl;
			
			switch(SNPValue){
				case 0:
					jump = j+2;
					break;
				case 1:
					temp = j+1;
					//cout << "Index " << temp << "\n";
					varFound = 0;
					while(!oneFound){
					//	cout << "in Case 1 while\n";
					//	cout << "Index " << temp << "\n";
						if(tree[temp]->get_isVariable()){
							varFound++;
							temp++;
					//		cout << "Variable found --> " << varFound << "\n";
						}
						else if((tree[temp]->get_name())!="1"){
					//		cout << tree[temp]->get_name() << "--> not one!\n";							
							temp++;
							
						}
					//	if((tree[temp]->evaluate())!=SNPValue && !(tree[temp]->get_isVariable()))
					//		temp++;
					//	else if(tree[temp]->get_isVariable())
					//		varFound++;
						else if((tree[temp]->get_name())=="1"){
					//		cout << tree[temp]->get_name() << "--> one found!\n";
							if(varFound >= 1){
								varFound--;
								temp++;
					//			cout << "Variable count decremented --> " << varFound << "\n";
							}
							else{
								oneFound = true;
								jump = temp + 1;
					//			cout << "Variable count already zero, location of 'one' found\n";
							}
						}
					}
					//jump = j+4;
//					jump = temp + 1;
					oneFound = false;
					break;
				case 2:
					temp = j+1;
					varFound = 0;
					while(!twoFound){
						if(tree[temp]->get_isVariable()){
							varFound++;
							temp++;
					//		cout << "Variable found --> " << varFound << "\n";
						}
						else if((tree[temp]->get_name())!="2"){						
					//		cout << tree[temp]->get_name() << "--> not two!\n";	
							temp++;				
						}	
						else if((tree[temp]->get_name())=="2"){
					//		cout << tree[temp]->get_name() << "--> two found!\n";
							if(varFound >= 1){
								varFound--;
								temp++;
					//			cout << "Variable count decremented --> " << varFound << "\n";
							}
							else{
								twoFound = true;
								jump = temp + 1;
					//			cout << "Variable count already zero, location of 'one' found\n";
							}
						}
					}
					//jump = j+6;
					twoFound = false;
					break;
			}
			
			j = jump;
		}
		
		//cout << "Index " << j << " in the tree is a class" << endl;
		result = tree[j]->evaluate();
		//cout << "Its value is " << result << endl;
			
		// add balanced accuracy calculation 
		// 7/14/06
		//nihard - fix it on 10/24/08
		if(result == ind_status[i]) {
			//total_wrong++;
			total_right++;
			// if affected increment casewrong
			if(ind_status[i]) {
				caseright++;
			}
			else {
				controlright++;
			}
   		} 
	}
	catch(ErrorExcept & e){
		if(e.code() != ErrorExcept::missingData)
				throw(e);
		else{
			if (missing_count < MAX_MISSING) {
				cout << "missing found and ignored" << endl;
					missing_count++;
			}
		}
	}
		
  } /*End eval for each individual*/ 
	
	
		/*Determine total number of cases/controls*/
	int num_cases = 0, num_controls = 0;
	for (int i = 0; i < vector_size; i++) {
		if (ind_status[i]) {
			num_cases++;
		}
		else {
			num_controls++;
		}
	} /*End foreach individual*/
	
	int casewrong, controlwrong;
	
	casewrong = num_cases - caseright;
	controlwrong = num_controls - controlright;
	
	int total_wrong;
	total_wrong = casewrong + controlwrong;
    
  // sensitivity = a/(a+c)
  // specificity = d/(b+d)
  if(fitnessType == classError){  
    return double(total_wrong)/vector_size;
  }
  // balanced accuracy is the average of sensitivity and specificity
  else if (fitnessType == balancedAcc) {
	//cerr << "returning from determine_error_rate()\n";
//cout << "Value is " << (1-.5 * (double(caseright) / (caseright + casewrong) + 
  //  double(controlright) /(controlright + controlwrong))) << "\n";
//	cout << "caseright, casewrong, controlright, controlwrong: " << caseright << "," << casewrong << "," << controlright << "," << controlwrong <<"\n";
    return 1-.5 * (double(caseright) / (caseright + casewrong) + 
    double(controlright) /(controlright + controlwrong));

  }
	else if (fitnessType == weightedCE) {
		
		double retval =  (((double(vector_size) / num_cases) * casewrong +
													(double(vector_size) / num_controls) * controlwrong) /
												 (2 * vector_size));
		
		/*cerr << "num cases: " << num_cases << " num controls: " << num_controls <<
			" casewrong: " << casewrong << " controlwrong: " << controlwrong << 
			" weightedCE: " << retval << "\n"*/;
		//double classE = double(total_wrong)/vector_size;
		//cerr << "classE: " << classE << " weightedCE: " << retval << "\n";
		return retval;

	} /*End weightedCE*/
	else {
		cerr << "ERROR:  unknown fitness type\n";
		exit(1);
	}
cerr << "Tester.cpp: reached end of determine_error_rate()\n";
}


///
/// Sets fitness type so either classification error or
/// balanced accuracy will be returned
/// @param fitType enum lising fitness type to be used
///
void Tester::set_fitness_type(FitnessTypes fitType){
  fitnessType = fitType;
}
