#!/usr/bin/perl
#
# A perl script to change genotype data (0,1,2) 
# into dummy variables (-1-1,02,1-1)  Make sure to notice the index of
# variable $i because if you are using neural networks, 
# you do not want affected status    0-MDR  1-gpnn 0-nevprop 
#
# usage
# dummy.pl name.data firstdata lastdata 
#  
# written by MDR on February 20, 2001
# edited by MDR on August 8, 2001
# edited by MDR on November 5,2001
#
#
#
if (($#ARGV == 0) && ($ARGV[0] eq "help")) 
	{    #no arguments or help
 	$ArgCount = $#ARGV + 1;
	print "=======================================================\n";
	print "              $0 Help\n";
	print "This program uses MDR to generate error rates\n";
	print "for multiple data sets.\n";
	print "Usage : $0 DataName FirstData LastData \n";
	print "Example : $0 Sim.data 1 10 \n";
	print "The above example will generate new datasets with dummy variables \n";
	print "========================================================\n";
	exit;
	}

if($#ARGV != 2)
	{ #improper number of arguments
	$ArgCount = $#ARGV + 1;
	print "$0 cannot work with $ArgCount arguments.\n";
	print "Usage : $0 DataName FirstData LastData \n";
	print "Example : $0 Sim.data 1 10 \n";
	exit;
	}
$DataName = $ARGV[0];
$FirstData = eval($ARGV[1] + 0);
$LastData = eval($ARGV[2] + 0);

$datset = "dataset";

($FilePrefix,$rest) = split /\.data/, $DataName,2;
@DirParts = split/\//,$FilePrefix;  #remove preceding reference directories
$FilePrefix = $DirParts[$#DirParts];
print "File name to be used: ${FilePrefix}\n";

$LastDataCount = eval($LastData + 1);
$dat = "dat";
$dummy = "ott-dummy";

$dumone = "-1 -1 ";
$dumtwo = "0 2 ";
$dumthree = "1 -1 ";
$dumfour = "3 3 ";

# loop for all datasets

for($I = $FirstData; $I < $LastDataCount; $I++)
	{
	open(OUTFILE,">$FilePrefix.$I.$dummy.txt") or die "Can't write to '$dummy.txt': $!";
	open(INFILE,"<$FilePrefix.$I.txt") or die "Can't  read from '$FilePrefix.$I.txt': $!";			
			
		while($line = <INFILE>)
			{	
			
				# print "$line \n";

				@char = split/\s+/,$line;
				# printf OUTFILE "$char1";
				# print "$char1\n";

			for($i = 1; $i <= $#char; $i++)
			{
				if($char[$i] eq "0")
					{
					print OUTFILE"$dumone";
				
					
					}
				elsif($char[$i] eq "1")
					{
					print OUTFILE"$dumtwo";
				
					}
				elsif($char[$i] eq "2")
					{
					print OUTFILE"$dumthree";
					
					}
				elsif($char[$i] eq "3")
                                        {
                                        print OUTFILE"$dumfour";

                                        }
			
			}	
					printf OUTFILE "$char[0]";
					printf OUTFILE "\n";	
			}
	close INFILE;
	close OUTFILE;
	}
