#!/usr/local/bin/perl

#Given a set of simplecount output filenames on STDIN, see what % of the time 
#they contain the given variables

use strict;

#my $threshold = 100;
#my @varlist = ('4', '9', '14');
#my @varlist = ('4');
#my @varlist = ('4', '9')
my @varlist = split(':', $ARGV[0]);

#my $var1 = '5';
#my $var2 = '10';
#my $varcount = 2;


my $varcount = scalar(@varlist);
my $counter = 0;
my $singlecount = 0;
my $allcount = 0;
my $avgminyes = 0;
my $avgmaxnon = 0;

my $totalnum_yes;
my $totalavg_yes;
my $totalnum_non;
my $totalavg_non;


foreach my $var (@varlist) {
		print "Var: $var\n";		
}


while (<STDIN>) {
		chomp;
		my @contents = `cat $_`;
		my $varsfound = 0;

		my $maxnon = -1;
		my $minyesstart = 200;
		my $minyes = $minyesstart;

		next if ( scalar(@contents) < 5);

		$counter++;
		
		foreach my $line (@contents) {

				chomp $line;
				my ($var, $percent) = ($line =~ /^(\S+)\s+\S+\s+(\S+)/);
				
				next if ( (!($var =~ /\d+/)) || (!($percent =~ /\d+/)) );

				my $isone = 0;
				foreach my $var0 (@varlist) {
						if ($var eq $var0) {
								$isone = 1;
								#print "$var isone (eq $var0)\n";
						}
				}

				if (1 == $isone) {
						$totalnum_yes++;
						$totalavg_yes += $percent;
				}
				else {
						$totalnum_non++;
						$totalavg_non += $percent;
				}
				

				if ( ($percent > $maxnon) && ($isone != 1) ) {
						#print "$percent - $maxnon - $isone\n";
						
						$maxnon = $percent;
						#print "Setting maxnon - $maxnon\n";
				}

				foreach my $var0 (@varlist) {
						if ($var eq $var0) {
								#print "Found $var with $percent\%\n";
								$varsfound++;

								if ($percent < $minyes) {
										$minyes = $percent;
								}


								#Take care of out-of-order results
								if ($minyes <= $maxnon) {
										$varsfound--;
								}
						}
				}


		} #end foreach line of .counted


		#If the variable isn't found
		if ($minyes == $minyesstart) {
				$minyes = 0;
		}

		$avgminyes += $minyes;
		$avgmaxnon += $maxnon;
		$singlecount++ if ($varsfound > 0);
		$allcount++ if ($varsfound == $varcount);
} #end foreach .counted

$avgminyes /= $counter;
$avgmaxnon /= $counter;

$totalavg_yes /= $totalnum_yes;
$totalavg_non /= $totalnum_non;

print "Total number: $counter\n";
print "At least one found: $singlecount\n";
print "All variables found: $allcount\n";
print "AvgMinYes: $avgminyes - AvgMaxNon: $avgmaxnon\n";
print "AvgYes: $totalavg_yes - AvgNon: $totalavg_non\n";
