#!/usr/bin/perl

#for when countbyloci.pl is overkill.
#takes on standard in the output from a cross_validate.pl run, and parses
#it for loci.  Counts to compare runs and other fun stuff, with an end goal
#of helping to pick a final model.

my %locuscount = ();
my $singlecount = 0;

$singlecount = 1 if ($ARGV[0] eq '-single');

my $testsum = 0;
my $trainsum = 0;

my $counter = 0;
while (my $line = <STDIN>) {
		chomp $line;

		if ($line =~ /Testing misclassification: ([\d\.]+)/) {
				$testsum += $1;
		}
		elsif ($line =~ /Training misclassification: ([\d\.]+)/) {
				$trainsum += $1;
		}

		next if (!($line =~ /Loci used in the model/));
		my %seenhash = (); #$seenhash{5} = 'a'; if it's been seen in this line
		
		$line =~ s/.*Loci used in the model: //;
		my @loci = split(' ', $line);
		foreach my $locus (@loci) {
				my $reallocus = $locus;
				$reallocus = int(($locus + 1)/2) if (!$singlecount);
				#print "$locus -> $reallocus\n"; #debug
				if ($seenhash{$reallocus} ne 'a') {
						$locuscount{$reallocus} = 1 + $locuscount{$reallocus};
						$seenhash{$reallocus} = 'a';
				}
		}
		$counter++;
}
print "Runs: $counter (Make sure this is what you expect)\n";
print "Locus\tCount\t%\n";
print "Avg. training misclassification: " . $trainsum / $counter . "\n";
print "Avg. testing misclassification: " . $testsum / $counter . "\n";

foreach my $locus (sort {$locuscount{$b} <=> $locuscount{$a} } keys(%locuscount)) {
		print "$locus\t" . $locuscount{$locus} . "\t" . 
				int( 100* $locuscount{$locus} / $counter ) . "\n";
}
