#include "ErrorExcept.h"

///
/// constructor
///
ErrorExcept::ErrorExcept(){
        error = "No message set by code.";
        codeValue = generalError;
}

///
/// constructor
/// @param message error message
///
ErrorExcept::ErrorExcept(string message){
        error = message;
        codeValue = generalError;
}

///
/// alternate constructor
/// @param message error message 
/// @param eCode ErrorCodes identifying type of error
///
ErrorExcept::ErrorExcept(string message, ErrorCodes eCode){
        error = message;
        codeValue = eCode;
}

///
/// Returns error stored in exception object
/// @return error
///
string ErrorExcept::get_error(){
        return error;
}

///
/// Overloads output operator
/// @param os ostream to write to
/// @param ke ErrorExcept to output
/// @return output stream
///
ostream & operator << (ostream & os, const ErrorExcept & ke){
        os << ke.error;
        return os;
}
