package PVMController;
use Env;
use strict;

use vars qw(@ISA @EXPORT);

use Exporter;
use IPC::Open2;
@ISA = qw(Exporter);
@EXPORT = qw(pvmStart pvmHalt minMax);

sub pvmHalt{

  use vars qw($program $ppid $funcOut);
print "HALTING PVM\n";
  $program = "pvm";
  $ppid = open2(*README, *WRITEME, $program) or 
		return (1,"Problem running \"$program\".\n");
  local $/ = ">";
  $funcOut = "";
  $funcOut .= <README>;

  $funcOut .= "Halting pvm deamon.\n";
  printf WRITEME "halt\n";

  close WRITEME or  return (1,"Problem closing \"WRITEME\" pipe.\n");
  close README or return (1,"Problem closing \"README\" pipe.\n");
  waitpid( $ppid, 0 ) or return (1,"Problem terminating $program.\n");

  return (0,$funcOut);

}


sub pvmStart{

  use vars qw($program $ppid $funcOut $arg $next $done $nodeFile $out);

  $arg = $_[0];
  return (1,"The function \"pvmStart\" was not called correctly.\n") if @_ > 1;

  local $/ = ">";
  $funcOut = "";

  # `cp $ENV{PBS_NODEFILE} $arg` if -e $ENV{PBS_NODEFILE};
  if(!(-e $arg)){
    return (1,"The file \"$arg\" does not exist.\n"); 
  }

  $program = "pvm $arg";
print "$program\n";
  $ppid = open2(*README, *WRITEME, $program) or 
		return (1,"Problem running \"$program\".\n");
  $done = 0;
  $next = 0;

  $out = <README>;
  $funcOut .= $out;
  printf WRITEME "conf\n";
  $out = <README>;
  $funcOut .= $out;
  printf WRITEME "quit\n";
  $funcOut .= "Quiting pvm console.\n";

  close WRITEME or  return (1,"Problem closing \"WRITEME\" pipe.\n");
  close README or return (1,"Problem closing \"README\" pipe.\n");
  waitpid( $ppid, 0 ) or return (1,"Problem terminating $program.\n");

  return (0,$funcOut);
}

sub minMax{

  use vars qw($datafile $e $max $min @line);

  $datafile = $_[0];
  return "ERROR: Incorrect number of arguments.\n" if @_ != 1;
  return "ERROR: \"$datafile\" does not exist.\n" if !(-e $datafile);

  open(IF, "<$datafile");
  $max=-99999999;
  $min=99999999;
  while(<IF>){
     chomp;
     @line=split(/\s+/);
     foreach $e (@line){
       next if $e !~ /(\d+\.?\d*|\.\d+)/;
       $max = $e if $e > $max; 
       $min = $e if $e < $min;
     }
  }
  close IF;
 
  return ($min, $max);
}

# DEBUG
print "Successfully loaded PVMController module\n";
1;
