/* ----------------------------------------------------------------------------
  genome.h
  mbwall 5dec95
  Copyright (c) 1995-1996 Massachusetts Institute of Technology

 DESCRIPTION:
   This file contains the information needed to evaluate an operate on a 
genome in these examples.
---------------------------------------------------------------------------- */
#ifndef _genome_h_
#define _genome_h_

#include <ga/GABaseGA.h>
#include "GEBinStrBlockCrossGenome.h"
#include <vector>
#include "Element.h"
#include "Tester.h"
#include "Translator.h"
#include "Tree.hh"
#include <mpi.h>

void printGoodBad();

//#define DEBUG 0

extern Translator trans;
extern Tester genn_test;
extern Grammar gram;

#define GENOME_LENGTH 64

float GenomeEvaluator(GAGenome&);
int RecvMigration(GAGeneticAlgorithm& ga, int tid);
int SendMigration(int * toids, GAGeneticAlgorithm& ga, int count, int numIds);
int RecvPopulation(GAPopulation&, int tid);
int SendPopulation(int toid, const GAPopulation&);

/*Looks like dead code*/
/*int RecvStatistics(GAStatistics&);
	int SendStatistics(int toid, const GAStatistics&);*/

int UnpackIndividual(GAGenome& g);
int PackIndividual(GAGenome& g);

int PackIndividualBits(GAGenome& g, int * intbuf, int bufindex);
int UnpackIndividualBits(GAGenome& g, int * intbuf, int bufindex);

struct tree_node{
  Element * nodeElement;
  int ruleIndex;
};


extern ofstream debugfile;

void SensibleInitializer(GAGenome & c);
void add_rule_nodes(tree<tree_node> & tr, tree<tree_node>::iterator current_node, 
  int depth, bool fullTree);
int get_rule_index(Element * currentElement, int maxDepth, bool fullTree);

const int MSG_DONE                =1;
const int MSG_INITIALIZE          =2;
const int MSG_STEP                =3;
const int MSG_RECEIVE_MIGRATION   =4;
const int MSG_SEND_MIGRATION      =5;
const int MSG_SEND_POPULATION     =6;
const int MSG_SEND_STATISTICS     =7;
const int MSG_INCOMING_MIGRATION  =8;
const int MSG_INCOMING_POPULATION =9;
const int MSG_INCOMING_STATISTICS =10;
const int MSG_STEP_COMPLETE       =11;
const int MSG_SET_POPULATION_SIZE =12;
const int MSG_SET_RANDOM_SEED     =13;
const int MSG_SEND_BEST           =14;
const int MSG_MIGRATE_DONE        =15;
const int MSG_READY               =16;
const int MSG_SLAVE_EXITED        =17;
const int MSG_REMOVE_LOG          =18;
const int MSG_INCOMING_POPULATION_BITS    =19;
const int MSG_INCOMING_POPULATION_SCORES  =20;
const int MSG_INCOMING_MIGRATION_BITS     =21;
const int MSG_INCOMING_MIGRATION_SCORES   =22;

#endif
